var $ = jQuery;
$(function() {
	var Subject = $('input.InputSubject').val();
	var Grade = $('select.SelectDisGrade').val();
	var Bonus = $('input.BonusRate').prop("checked");
	var Control = $('input.ExamType').filter(':checked');
	var LectionCount = parseInt($('input.InputLectionCount').val());
	var PracticeCount = parseInt($('input.InputPracticeCount').val());


// ---- Изменения базовых параметров дисциплины ---
	
	// Изменение предмета
	$('select.SelectSubject').change(function()
	{
		var thisObj = $(this);
		$.post(
			URLdir + 'handler/map/ChangeDisciplineSubject',
			{
				'DisciplineID': DisciplineID,
				'SubjectID': $(this).val()
			},
			function(data) 
			{
				data = $.parseJSON(data);
				if(data.success === true) {
					Subject = thisObj.val();
					EventInspector_ShowMsg('Предмет изменен', 'success');
				}
				else { 
					EventInspector_ShowMsg('Ошибка: Изменение предмета', 'error');
					thisObj.val(Subject);
				}
			}
		);
	});
	
	// Изменение курса
	$('select.SelectDisGrade').change(function()
	{ // SelectGrade совпадает с другим, поэтому SelectDisGrade
		thisObj = $(this);
		$(this).prop('disabled', true);
 		$.post(
			URLdir + 'handler/map/ChangeDisciplineGrade',
			{
				'DisciplineID': DisciplineID,
				'GradeID': $(this).val()
			},
			function(data)
			{
				data = $.parseJSON(data);
				if(data.success === true) {
					EventInspector_ShowMsg('Курс изменен', 'success');
					Grade = thisObj.val();
				}
				else {
					thisObj.val(Grade);
				 	EventInspector_ShowMsg('Ошибка: Изменение курса', 'error');
				}
				thisObj.removeAttr('disabled');
			}
			
		);
	});
	
	// Бонусные баллы
	$('input.BonusRate').change(function()
	{
		var thisObj = $(this);
		$(this).attr('disabled', true);
		$.post(
			URLdir + 'handler/map/ChangeStatusBonusModule',
			{
				'DisciplineID': DisciplineID,
				'BonusRate': $(this).prop("checked")
			},
			function(data) {
				data = $.parseJSON(data);
				if(data.success === true) {
					var message = (data.action == 'add')? 	'Бонусные баллы добавлены'
														: 	'Бонусные баллы удалены';
					Bonus = thisObj.prop('checked');
					EventInspector_ShowMsg(message, 'success');
				}
				else {
					EventInspector_ShowMsg('Ошибка: Бонусные баллы', 'error');
					thisObj.prop("checked", Bonus);
				}
				thisObj.removeAttr('disabled');
			}
		);
	});
	
	// Изменение контроля
	$('input.ExamType').change(function()
	{
		var thisObj = $(this);
		var list = thisObj.siblings('input.ExamType');
		list.attr("disabled", true);
		$.post(
			URLdir + 'handler/map/ChangeDisciplineControl',
			{
				'DisciplineID': DisciplineID,
				'Control': $(this).val()
			},
			function(data) {
				data = $.parseJSON(data);
				if(data.success == 0) {
					Control = thisObj;
					EventInspector_ShowMsg('Форма контроля изменена', 'success');
				}
				else { 
					Control.prop('checked', true);
					if (data.success > 0)
						EventInspector_ShowMsg('Превышено максимальное кол-во баллов', 'error');	
					else 
						EventInspector_ShowMsg('Ошибка: Изменение формы контроля', 'error');
				}
				list.removeAttr('disabled');
			}
		);
	});
	

	LessonType = {
	    Practice: 	'0',
	    Lection: 	'1'
	};

	// Изменение лекционных часов
	$('input.InputLectionCount').focusout(function()
	{
		var thisObj = $(this);
		var value = parseInt($(this).val());
		if (value === LectionCount)
			return;

		$(this).prop('disabled', true);
		$.post(
			URLdir + 'handler/map/ChangeDisciplineHours',
			{
				'DisciplineID': DisciplineID,
				'Hours': value,
				'Type': LessonType.Lection
			},
			function(data) 
			{
				data = $.parseJSON(data);
				if(data.success === true) {
					LectionCount = value;
					EventInspector_ShowMsg('Лекционные часы изменен', 'success');
				}
				else { 
					EventInspector_ShowMsg('Ошибка: Изменение лекционных часов', 'error');
					thisObj.val(LectionCount);
				}

				thisObj.removeAttr('disabled');
			}
		);
	})
	.keydown(function(event) {
		KeyDownOnlyNumber(event);
    });

	
	// Изменение практических часов
	$('input.InputPracticeCount').focusout(function()
	{
		var thisObj = $(this);
		var value = parseInt($(this).val());
		if (value === LectionCount)
			return;
		$(this).prop('disabled', true);
		$.post(
			URLdir + 'handler/map/ChangeDisciplineHours',
			{
				'DisciplineID': DisciplineID,
				'Hours': value,
				'Type': LessonType.Practice
			},
			function(data) 
			{
				data = $.parseJSON(data);
				if(data.success === true) {
					PracticeCount = value;
					EventInspector_ShowMsg('Практические часы изменен', 'success');
				}
				else {
					thisObj.val(PracticeCount);
					EventInspector_ShowMsg('Ошибка: Изменение практических часов', 'error');
				}

				thisObj.removeAttr('disabled');
			}
		);
	})
	.keydown(function(event) {
		KeyDownOnlyNumber(event);
    });
	
});